/*#######################################################################################
Communication between AVR and Navilock GPS Modules 

Copyright (C) 2008 Martin Matysiak

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@k621.de

Datenbltter zum Umgang mit Navilock GPS Modulen:

http://www.navilock.de/download/Dokumente_SLASH_Sonstiges/60415_-_Datenblatt_u-blox_GPS_Module/481
http://www.sparkfun.com/datasheets/GPS/NMEA%20Reference%20Manual1.pdf


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "gps.h"

//############################################################################
//Routine zur Initialisierung des GPS Moduls
unsigned char gps_init()
//############################################################################
{
	//USART Schnittstelle initalisieren
	uart_init(UART_BAUD_SELECT(GPS_BAUD, F_CPU));

	sei();

	//Bytefolge senden, um in NMEA Modus zu gelangen
	/*unsigned char mode[] = { 0xA0, 0xA2, 0x00, 0x18,
		0x81, 0x01, 0x01, 0x01, 0x00, 0x01,
		0x00, 0x01, 0x00, 0x01, 0x00, 0x01,
		0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
		0x00, 0x01, 0x00, 0x00, 0x12, 0xC0,
		0x01, 0x5D, 0xB0, 0xB3 };

	gps_send_chars(mode);*/

	return(1);
}

//############################################################################
//Fordert vom Modul die aktuelle Position an und gibt die NMEA Nachricht als
//String zurck
char gps_get_char()
//############################################################################
{
	unsigned int in = 0;
	char out = '%';

	do {
		in = uart_getc();
	} while(in & UART_NO_DATA);

	if (in & UART_BUFFER_OVERFLOW) {
		out = '';
	} else {
		out = (char) in;
		if (out == '$') {
			PORTC ^= 0x01;
		}
	}

	return(out);
}

//############################################################################
//Versendet ein Array aus Zeichen
/*void gps_send_chars(unsigned char input[]) 
//############################################################################
{
	for (unsigned short i = 0; i < 32; i++) {
		PORTC = 0x02;
		uart_putc(input[i]);
		PORTC = 0x00;
	}
}*/
